unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, MathExpression;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    ListBox1: TListBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Image1: TImage;
    Button2: TButton;
    ProgressBar1: TProgressBar;
    Evaluate: TButton;
    ExpressionEdit: TEdit;
    procedure ListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure EvaluateClick(Sender: TObject);
  private
    procedure BuildGraph(Value: String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  radian = 180 / pi;

implementation

{$R *.dfm}

procedure TForm1.BuildGraph(Value: String);
var
  i, y: Integer;
  x: Extended;
  ErrorCode, ClientH, ClientW: Word;
  Time1: LongWord;
  Res: String;
begin
  ProgressBar1.Position := 0;

  Time1 := GetTickCount;

  Memo1.Lines.Clear;
  if Pos('y=', Value) > 0 then
    Value := Copy(Value, 3, 255);

  Image1.Canvas.Lock;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
  Image1.Canvas.MoveTo(Image1.Width div 2, 0);
  Image1.Canvas.LineTo(Image1.Width div 2, Image1.Height);
  Image1.Canvas.MoveTo(0, Image1.Height div 2);
  Image1.Canvas.LineTo(Image1.Width, Image1.Height div 2);


  ClientW := Image1.Width div 2; ClientH := Image1.Height div 2;
  {x+}
  x := 0;
  for i := 0 to 1500 do
  begin
    ErrorCode := CalcGraphExpression(Value, x * radian, Res);
    if ErrorCode <> C_NOERROR then
    begin
      Memo1.Lines.Add('Error during building the first graph: ' + CalcErrorToStr(ErrorCode));
      Break;
    end;
    y := - Trunc(StrToFloat(Res) * 10) + ClientH;
    if (y >= 0) or (y <= Image1.Height) then
      Image1.Canvas.Pixels[Trunc(x * 1000) + ClientW, y] := RGB($FF, 0, 0);
    x := x + 0.0001;

    if i mod 30 = 0 then {1500 / 50%}
      ProgressBar1.Position := ProgressBar1.Position + 1;
  end;

  {x-}
  x := 0;
  for i := 0 to 1500 do
  begin
    ErrorCode := CalcGraphExpression(Value, x * radian, Res);
    if ErrorCode <> C_NOERROR then
    begin
      Memo1.Lines.Add('Error during building the second graph: ' + CalcErrorToStr(ErrorCode));
      Break;
    end;
    y := - Trunc(StrToFloat(Res) * 10) + ClientH;
    if (y >= 0) or (y <= Image1.Height) then
      Image1.Canvas.Pixels[Trunc(x * 1000) + ClientW, y] := RGB($FF, 0, 0);

    x := x - 0.0001;

    if i mod 30 = 0 then {1500 / 50%}
      ProgressBar1.Position := ProgressBar1.Position + 1;
  end;
  Image1.Canvas.Unlock;

  Memo1.Lines.Add('Time elapsed: ' + IntToStr(GetTickCount - Time1) + 'ms')
end;


procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> - 1 then
  begin
    Edit1.Text := ListBox1.Items[ListBox1.ItemIndex];
    BuildGraph(ListBox1.Items[ListBox1.ItemIndex]);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  BuildGraph(Edit1.Text);
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  with TSaveDialog.Create(Self) do
  begin
    Filter := 'Image files (*.bmp)|*.bmp';
    DefaultExt := 'bmp';
    if Execute then
      Image1.Picture.SaveToFile(FileName);
    Free;
  end;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  Button2.Click;
end;

procedure TForm1.EvaluateClick(Sender: TObject);
var
  ErrorCode: Word;
  Res: String;
begin
  Memo1.Lines.Clear;
  ErrorCode := CalcExpression(ExpressionEdit.Text, Res);
  if ErrorCode <> C_NOERROR then
  begin
    Memo1.Lines.Add('Cannot evaluate expression: ' + CalcErrorToStr(ErrorCode));
    Exit;
  end else
    Memo1.Lines.Add('Result: ' + Res)
end;

end.
